#!/bin/sh
failed=0; all=0; xfail=0; xpass=0; skip=0; \
srcdir=.; export srcdir; \
list='a8-mask caps-joins caps-sub-paths clip-all clip-nesting clip-operator clip-twice composite-integer-translate-source composite-integer-translate-over composite-integer-translate-over-repeat create-from-png create-from-png-stream dash-caps-joins dash-offset-negative fill-and-stroke fill-rule filter-nearest-offset get-and-set gradient-alpha leaky-polygon line-width linear-gradient mask mask-ctm mask-surface-ctm move-to-show-surface nil-surface operator-clear operator-source paint paint-with-alpha pixman-rotate rectangle-rounding-error scale-source-surface-paint select-font-no-show-text self-copy self-intersecting set-source show-text-current-point source-clip source-surface-scale-paint surface-pattern text-antialias-gray text-antialias-subpixel text-cache-crash text-pattern text-rotate transforms translate-show-surface trap-clip unantialiased-shapes unbounded-operator  rel-path pthread-show-text ft-font-create-for-ft-face   xlib-surface'; \
if test -n "$list"; then \
  for tst in $list; do \
    if test -f ./$tst; then dir=./; \
    elif test -f $tst; then dir=; \
    else dir="./"; fi; \
    if  ${dir}$tst; then \
      all=`expr $all + 1`; \
      case " a8-mask filter-nearest-offset pixman-rotate self-intersecting text-rotate " in \
      *" $tst "*) \
	xpass=`expr $xpass + 1`; \
	failed=`expr $failed + 1`; \
	echo "XPASS: $tst"; \
      ;; \
      *) \
	echo "PASS: $tst"; \
      ;; \
      esac; \
    elif test $? -ne 77; then \
      all=`expr $all + 1`; \
      case " a8-mask filter-nearest-offset pixman-rotate self-intersecting text-rotate " in \
      *" $tst "*) \
	xfail=`expr $xfail + 1`; \
	echo "XFAIL: $tst"; \
      ;; \
      *) \
	failed=`expr $failed + 1`; \
	echo "FAIL: $tst"; \
      ;; \
      esac; \
    else \
      skip=`expr $skip + 1`; \
      echo "SKIP: $tst"; \
    fi; \
  done; \
  if test "$failed" -eq 0; then \
    if test "$xfail" -eq 0; then \
      banner="All $all tests passed"; \
    else \
      banner="All $all tests behaved as expected ($xfail expected failures)"; \
    fi; \
  else \
    if test "$xpass" -eq 0; then \
      banner="$failed of $all tests failed"; \
    else \
      banner="$failed of $all tests did not behave as expected ($xpass unexpected passes)"; \
    fi; \
  fi; \
  dashes="$banner"; \
  skipped=""; \
  if test "$skip" -ne 0; then \
    skipped="($skip tests were not run)"; \
    test `echo "$skipped" | wc -c` -le `echo "$banner" | wc -c` || \
      dashes="$skipped"; \
  fi; \
  report=""; \
  if test "$failed" -ne 0 && test -n "http://bugs.freedesktop.org/enter_bug.cgi?product=cairo"; then \
    report="Please report to http://bugs.freedesktop.org/enter_bug.cgi?product=cairo"; \
    test `echo "$report" | wc -c` -le `echo "$banner" | wc -c` || \
      dashes="$report"; \
  fi; \
  dashes=`echo "$dashes" | sed s/./=/g`; \
  echo "$dashes"; \
  echo "$banner"; \
  test -z "$skipped" || echo "$skipped"; \
  test -z "$report" || echo "$report"; \
  echo "$dashes"; \
  test "$failed" -eq 0; \
else :; fi
if test -n "$list"; then
  rm -f journal.cairo 
  for tst in $list; do
    cat "journal.$tst" >> journal.cairo
    rm -f "journal.$tst"
  done
fi
